VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIDCDSPFilterInterface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private m_objIDCDSPFilterInterface As IDCDSPFilterInterface
Private m_blnDisableSaving As Boolean
Private m_blnPCMDataBeforeMainDSP As Boolean
Private m_lngPluginOwnerWindow As Long
Private m_objIDCDSPFilterPCMCallBack As IDCDSPFilterPCMCallBack

Public Property Get Object() As IDCDSPFilterInterface
    Set Object = m_objIDCDSPFilterInterface
End Property

Public Property Set Object(ByRef objIDCDSPFilterInterface As IDCDSPFilterInterface)
    Set m_objIDCDSPFilterInterface = objIDCDSPFilterInterface
End Property

Public Property Get CallBackPCM() As IDCDSPFilterPCMCallBack
    Set CallBackPCM = m_objIDCDSPFilterPCMCallBack
End Property

Public Property Set CallBackPCM(ByRef Callback As IDCDSPFilterPCMCallBack)
    Set m_objIDCDSPFilterPCMCallBack = Callback
    Call m_objIDCDSPFilterInterface.set_CallBackPCM(m_objIDCDSPFilterPCMCallBack)
End Property

'Callbacks for PCM Data
Public Property Get PCMDataBeforeMainDSP() As Boolean
    PCMDataBeforeMainDSP = m_blnPCMDataBeforeMainDSP
End Property

Public Property Let PCMDataBeforeMainDSP(ByVal Before As Boolean)
    m_blnPCMDataBeforeMainDSP = Before
    Call m_objIDCDSPFilterInterface.set_PCMDataBeforeMainDSP(IIf(m_blnPCMDataBeforeMainDSP, CLng(-1), CLng(0)))
End Property

'Winamp 2.x DSP Plugins
Public Sub SetDSPPlugin(ByVal hWnd As Long, ByVal Path As String)
    Call m_objIDCDSPFilterInterface.set_DSPPlugin(hWnd, Path)
End Sub

Public Property Get GetDSPPlugin() As String
    Dim strReturn As String
    
    Call m_objIDCDSPFilterInterface.get_DSPPlugin(strReturn)
    GetDSPPlugin = strReturn
End Property

Public Property Get DSPCount() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_DSPCount(lngReturn)
    DSPCount = lngReturn
End Property

Public Property Get DSPDescription() As String
    Dim strReturn As String
    
    Call m_objIDCDSPFilterInterface.get_DSPDescription(strReturn)
    DSPDescription = strReturn
End Property

Public Property Get DSPSubDescription(ByVal Index As Long) As String
    Dim strReturn As String
    
    Call m_objIDCDSPFilterInterface.get_DSPSubDescription(Index, strReturn)
    DSPSubDescription = strReturn
End Property

Public Property Let DSPSubPlugin(ByVal Index As Long)
    Call m_objIDCDSPFilterInterface.set_DSPSubPlugin(Index)
End Property

Public Property Get DSPSubPlugin() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_DSPSubPlugin(lngReturn)
    DSPSubPlugin = lngReturn
End Property

Public Sub ShowConfig()
    Call m_objIDCDSPFilterInterface.set_ShowConfig
End Sub

Public Sub UnloadDSPPlugin()
    Call m_objIDCDSPFilterInterface.set_UnloadDSPPlugin
End Sub

Public Property Get EnableDSPPlug() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableDSPPlug(lngReturn)
    EnableDSPPlug = (lngReturn <> CLng(0))
End Property

Public Property Let EnableDSPPlug(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableDSPPlug(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get PluginOwnerWindow() As Long
    PluginOwnerWindow = m_lngPluginOwnerWindow
End Property

Public Property Let PluginOwnerWindow(ByVal Window As Long)
    m_lngPluginOwnerWindow = Window
    Call m_objIDCDSPFilterInterface.set_PluginOwnerWindow(m_lngPluginOwnerWindow)
End Property

'Winamp Vis Plugins
Public Property Get WinampVisInterval() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_WinampVisInterval(lngReturn)
    WinampVisInterval = lngReturn
End Property

Public Property Let WinampVisInterval(ByVal Interval As Long)
    Call m_objIDCDSPFilterInterface.set_WinampVisInterval(Interval)
End Property

Public Property Get WinampVisPlugin(ByVal Plugin As String) As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_WinampVisPlugin(Plugin, lngReturn)
    WinampVisPlugin = lngReturn
End Property

Public Property Let WinampVisPlugin(ByVal Plugin As String, ByVal Index As Long)
    Call m_objIDCDSPFilterInterface.set_WinampVisPlugin(Plugin, Index)
End Property

Public Property Get WinampVisAutostart() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_WinampVisAutostart(lngReturn)
    WinampVisAutostart = (lngReturn <> CLng(0))
End Property

Public Property Let WinampVisAutostart(ByVal Autostart As Boolean)
    Call m_objIDCDSPFilterInterface.get_WinampVisAutostart(IIf(Autostart, CLng(-1), CLng(0)))
End Property

Public Sub StopWinampVisPlugin()
    Call m_objIDCDSPFilterInterface.set_StopWinampVisPlugin
End Sub

'Delay functions for delaying the Audio Stream through Timestamps
Public Property Get EnableDelay() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableDelay(lngReturn)
    EnableDelay = (lngReturn <> CLng(0))
End Property

Public Property Let EnableDelay(ByVal Enabled As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableDelay(IIf(Enabled, CLng(-1), CLng(0)))
End Property

Public Property Get Delay() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_Delay(lngReturn)
    Delay = lngReturn
End Property

Public Property Let Delay(ByVal Delay As Long)
    Call m_objIDCDSPFilterInterface.set_Delay(Delay)
End Property

'Functions to work with DSP Filters
Public Property Get FilterCount() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_FilterCount(lngReturn)
    FilterCount = lngReturn
End Property

Public Property Get FilterType(ByVal Index As Long) As TDCFilterType
    Dim lngReturn As TDCFilterType
    
    Call m_objIDCDSPFilterInterface.get_FilterType(Index, lngReturn)
    FilterType = lngReturn
End Property

Public Sub AddFilter(ByVal Index As Long, ByVal FilterType As TDCFilterType)
    Call m_objIDCDSPFilterInterface.set_AddFilter(Index, FilterType)
End Sub

Public Property Get FilterName(ByVal Index As Long)
    Dim strReturn As String
    
    Call m_objIDCDSPFilterInterface.get_FilterName(Index, strReturn)
    FilterName = strReturn
End Property

Public Property Get WindowShown(ByVal Index As Long) As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_WindowShown(Index, lngReturn)
    WindowShown = (lngReturn <> CLng(0))
End Property

Public Property Let WindowShown(ByVal Index As Long, ByVal Shown As Boolean)
    Call m_objIDCDSPFilterInterface.set_WindowShown(Index, IIf(Shown, CLng(-1), CLng(0)))
End Property

Public Sub DeleteFilter(ByVal Index As Long)
    Call m_objIDCDSPFilterInterface.set_DeleteFilter(Index)
End Sub

Public Property Get EnableFilter(ByVal Index As Long) As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableFilter(Index, lngReturn)
    EnableFilter = (lngReturn <> CLng(0))
End Property

Public Property Let EnableFilter(ByVal Index As Long, ByVal Enabled As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableFilter(Index, IIf(Enabled, CLng(-1), CLng(0)))
End Property

Public Sub RemoveAllFilters()
    Call m_objIDCDSPFilterInterface.set_RemoveAllFilters
End Sub

Public Sub MoveFilter(ByVal FromIndex As Long, ByVal ToIndex As Long)
    Call m_objIDCDSPFilterInterface.set_MoveFilter(FromIndex, ToIndex)
End Sub

Public Sub ResetShownWindows()
    Call m_objIDCDSPFilterInterface.set_ResetShownWindows
End Sub

Public Property Get FilterClass(ByVal Index As Long) As IUnknown
    Dim objReturn As IUnknown
    
    Call m_objIDCDSPFilterInterface.get_FilterClass(Index, objReturn)
    Set FilterClass = objReturn
End Property

Public Property Get FilterInterface(ByVal Index As Long) As IUnknown
    Dim objReturn As IUnknown
    
    Call m_objIDCDSPFilterInterface.get_FilterInterface(Index, objReturn)
    Set FilterInterface = objReturn
End Property

Public Property Get FilterItem(ByVal lngIndex As Long) As IUnknown
    Dim objReturn As IUnknown
    
    Call m_objIDCDSPFilterInterface.get_FilterItem(lngIndex, objReturn)
    Set FilterItem = objReturn
End Property

Public Property Get PresetCount() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_PresetCount(lngReturn)
    PresetCount = lngReturn
End Property

Public Property Get PresetExist(ByVal Name As String) As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_PresetExist(Name, lngReturn)
    PresetExist = (lngReturn <> CLng(0))
End Property

Public Property Get PresetName(ByVal Index As Long) As String
    Dim strReturn As String
    
    Call m_objIDCDSPFilterInterface.get_PresetName(Index, strReturn)
    PresetName = strReturn
End Property

Public Sub LoadPreset(ByVal Name As String)
    Call m_objIDCDSPFilterInterface.set_LoadPreset(Name)
End Sub

Public Sub SavePreset(ByVal Name As String)
    Call m_objIDCDSPFilterInterface.set_SavePreset(Name)
End Sub

Public Sub DeletePreset(ByVal Name As String)
    Call m_objIDCDSPFilterInterface.set_DeletePreset(Name)
End Sub

'Stream Switching
Public Property Get EnableStreamSwitching() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableStreamSwitching(lngReturn)
    EnableStreamSwitching = (lngReturn <> CLng(0))
End Property

Public Property Let EnableStreamSwitching(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableStreamSwitching(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get EnableStreamSwitchingInterface() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableStreamSwitchingInterface(lngReturn)
    EnableStreamSwitchingInterface = (lngReturn <> CLng(0))
End Property

Public Property Let EnableStreamSwitchingInterface(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableStreamSwitchingInterface(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get ForceStreamSwitchingDisconnect() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_ForceStreamSwitchingDisconnect(lngReturn)
    ForceStreamSwitchingDisconnect = (lngReturn <> CLng(0))
End Property

Public Property Let ForceStreamSwitchingDisconnect(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_ForceStreamSwitchingDisconnect(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get ForceStreamSwitchingStopFilter() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_ForceStreamSwitchingStopFilter(lngReturn)
    ForceStreamSwitchingStopFilter = (lngReturn <> CLng(0))
End Property

Public Property Let ForceStreamSwitchingStopFilter(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_ForceStreamSwitchingStopFilter(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get EnableStreamLimitInstance() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableStreamLimitInstance(lngReturn)
    EnableStreamLimitInstance = (lngReturn <> CLng(0))
End Property

Public Property Let EnableStreamLimitInstance(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableStreamLimitInstance(IIf(Enable, CLng(-1), CLng(0)))
End Property

'Bitrate Conversion
Public Property Get EnableBitrateConversion() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableBitrateConversion(lngReturn)
    EnableBitrateConversion = (lngReturn <> CLng(0))
End Property

Public Property Let EnableBitrateConversion(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableBitrateConversion(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get EnableBitrateConversionBeforeDSP() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableBitrateConversionBeforeDSP(lngReturn)
    EnableBitrateConversionBeforeDSP = (lngReturn <> CLng(0))
End Property

Public Property Let EnableBitrateConversionBeforeDSP(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableBitrateConversionBeforeDSP(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get BitrateConversionBits() As TDCBitRate
    Dim lngReturn As TDCBitRate
    
    Call m_objIDCDSPFilterInterface.get_BitrateConversionBits(lngReturn)
    BitrateConversionBits = lngReturn
End Property

Public Property Let BitrateConversionBits(ByVal Bits As TDCBitRate)
    Call m_objIDCDSPFilterInterface.set_BitrateConversionBits(Bits)
End Property

'Misc Settings
Public Property Get StreamInfo() As DSStream
    Dim lngDSStreamPtr As Long
    Dim udtReturn As DSStream
    
    Call m_objIDCDSPFilterInterface.get_StreamInfo(lngDSStreamPtr)
    CopyMemory udtReturn, ByVal lngDSStreamPtr, Len(udtReturn)
    StreamInfo = udtReturn
End Property

Public Property Get DisableSaving() As Boolean
    DisableSaving = m_blnDisableSaving
End Property

Public Property Let DisableSaving(ByVal Disable As Boolean)
    m_blnDisableSaving = Disable
    Call m_objIDCDSPFilterInterface.set_DisableSaving(IIf(Disable, CLng(-1), CLng(0)))
End Property

Public Property Get FilterVersion() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_FilterVersion(lngReturn)
    FilterVersion = lngReturn
End Property

Public Property Get Instance() As Long
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_Instance(lngReturn)
    Instance = lngReturn
End Property

Public Property Get CPUUsage() As Double
    Dim dblReturn As Double
    
    Call m_objIDCDSPFilterInterface.get_CPUUsage(dblReturn)
    CPUUsage = dblReturn
End Property

Public Property Get EnablePropertyPage() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnablePropertyPage(lngReturn)
    EnablePropertyPage = (lngReturn <> CLng(0))
End Property

Public Property Let EnablePropertyPage(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnablePropertyPage(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get TrayiconVisible() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_TrayiconVisible(lngReturn)
    TrayiconVisible = (lngReturn <> CLng(0))
End Property

Public Property Let TrayiconVisible(ByVal Visible As Boolean)
    Call m_objIDCDSPFilterInterface.set_TrayiconVisible(IIf(Visible, CLng(-1), CLng(0)))
End Property

Public Property Get EnableBalloonHint() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableBalloonHint(lngReturn)
    EnableBalloonHint = (lngReturn <> CLng(0))
End Property

Public Property Let EnableBalloonHint(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableBalloonHint(IIf(Enable, CLng(-1), CLng(0)))
End Property

Public Property Get EnableROT() As Boolean
    Dim lngReturn As Long
    
    Call m_objIDCDSPFilterInterface.get_EnableROT(lngReturn)
    EnableROT = (lngReturn <> CLng(0))
End Property

Public Property Let EnableROT(ByVal Enable As Boolean)
    Call m_objIDCDSPFilterInterface.set_EnableROT(IIf(Enable, CLng(-1), CLng(0)))
End Property

