VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTDCSpectrum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, ByVal numBytes As Long)
Private Const conMaxChannels = 10
Private Const conMaxVisualSamples = 8192
Private Const conPi = 3.14159265358979
Private Const conTwoPi = 2 * conPi
Private Const conFourPi = 4 * conPi

Private m_blnLogarithmic As Boolean
Private m_enuWindow As TWindowMode
Private m_lngMinY As Long
Private m_lngMaxY As Long
'fFFT : TDCFFT;
Private m_lngFFTSize As Long
Private m_blnMixChannels As Boolean
'Private m_lngBuffer(0 To conMaxChannels - 1, 0 To conMaxVisualSamples - 1) As Long
Private m_lngBuffer() As Long
Public Event OnSpectrumData(ByRef Data() As Long, ByVal MinY As Long, ByVal MaxY As Long, ByVal NumSamples As Long, ByVal Channels As Long)
Private m_bytPreEmphasis As Byte
Private m_blnEnablePreEmphasis As Boolean
Private m_bytSampleSkip As Byte

'{ Array of TComplex Values. }
'Private m_udtComplex(8192) As TComplex
Private m_udtComplex() As TComplex

Private Type T24BitSample
    a0 As Byte  '0 to 255
    a1 As Byte  '0 to 255
    a2 As Byte  '-127 to 127
End Type

'Private Type TComplex
'    re As Single
'    im As Single
'End Type

Private Enum TDCFFTSize
    fts2 = 0
    fts4
    fts8
    fts16
    fts32
    fts64
    fts128
    fts256
    fts512
    fts1024
    fts2048
    fts4096
    fts8192
End Enum

Public Enum TWindowMode
    wmRectangular = 0
    wmHanning
    wmBartlett
    wmHamming
    wmGaussian
    wmBlackman
    wmBlackmanHarris
End Enum

Public Property Get Buffer() As Long()
    Buffer = m_lngBuffer
End Property

Public Property Get MinY() As Long
    MinY = m_lngMinY
End Property

Public Property Let MinY(ByVal lngNewValue As Long)
    m_lngMinY = lngNewValue
End Property

Public Property Get MaxY() As Long
    MaxY = m_lngMaxY
End Property

Public Property Let MaxY(ByVal lngNewValue As Long)
    m_lngMaxY = lngNewValue
End Property

Public Property Get MixChannels() As Boolean
    MixChannels = m_blnMixChannels
End Property

Public Property Let MixChannels(ByVal blnNewValue As Boolean)
    m_blnMixChannels = blnNewValue
End Property

Public Property Get FFTSize() As Long
    FFTSize = CLng(Round((Log(CDbl(m_lngFFTSize)) / Log(CDbl(2))) - CDbl(1)))
End Property

Public Property Let FFTSize(ByVal lngNewValue As Long)
    m_lngFFTSize = CLng(2) ^ (lngNewValue + CLng(1))
End Property

Public Property Get PreEmphasis() As Byte
    PreEmphasis = m_bytPreEmphasis
End Property

Public Property Let PreEmphasis(ByVal bytNewValue As Byte)
    m_bytPreEmphasis = bytNewValue
End Property

Public Property Get PreEmphasisEnabled() As Boolean
    PreEmphasisEnabled = m_blnEnablePreEmphasis
End Property

Public Property Let PreEmphasisEnabled(ByVal blnNewValue As Boolean)
    m_blnEnablePreEmphasis = blnNewValue
End Property

Public Property Get SampleSkip() As Byte
    SampleSkip = m_bytSampleSkip
End Property

Public Property Let SampleSkip(ByVal bytNewValue As Byte)
    m_bytSampleSkip = EnsureRange(bytNewValue, CByte(1), CByte(255))
End Property

Public Property Get WindowMode() As TWindowMode
    WindowMode = m_enuWindow
End Property

Public Property Let WindowMode(ByVal enuNewValue As TWindowMode)
    m_enuWindow = enuNewValue
End Property

Public Property Get Logarithmic() As Boolean
    Logarithmic = m_blnLogarithmic
End Property

Public Property Let Logarithmic(ByVal blnNewValue As Boolean)
    m_blnLogarithmic = blnNewValue
End Property

Private Sub Class_Initialize()
    'fFFT := TDCFFT.Create(Self);
    'fFFT.Scale := False;
    'fFFT.ReOrder := True;
    m_blnMixChannels = True
    m_bytSampleSkip = CByte(1)
    m_enuWindow = wmRectangular
    m_lngMinY = CLng(0)
    m_lngMaxY = CLng(100)
    m_blnEnablePreEmphasis = True
    m_bytPreEmphasis = CByte(90)
    m_blnLogarithmic = True
    FFTSize = fts1024
    Call Flush
End Sub

Private Sub DoPreEmphasis(ByRef Buffer() As TComplex, ByVal Value As Double)
    Dim lngIndex As Long
    Dim f, ac0 As Double
    
    f = Value * Buffer(0).re
    
    For lngIndex = CLng(1) To UBound(Buffer)
        On Local Error Resume Next
        ac0 = Value * Buffer(lngIndex).re
        Buffer(lngIndex).re = Buffer(lngIndex).re - f
        f = ac0
        If Err.Number <> CLng(0) Then Err.Clear
        On Local Error GoTo 0
    Next lngIndex
End Sub

Public Sub Process(ByVal BufferPtr As Long, ByVal Size As Long, ByVal Bits As Long, ByVal Channels As Byte, ByVal Float As Boolean)
    Dim bytBuf8() As Byte
    Dim intBuf16() As Integer
    Dim udtBuf24() As T24BitSample
    Dim lngBuf32i() As Long
    Dim sngBuf32() As Single   'Delphi Single Data Type
    Dim lngPChannels As Long
    Dim lngNumSamples As Long
    Dim i As Long, c As Long
    Dim lngTemp As Long     'tmp
    Dim lngChannels As Long 'ch
    Dim dblMultiple As Double   'Mul
    Dim lngRange As Long    'fRange
    Dim lngSkip As Long     'Skip
    Dim dblTemp2 As Double  'tmp2
    
    Dim udtComplexReturn() As TComplex  'manually added
    
    If (BufferPtr = CLng(0)) Or (Size = CLng(0)) Or (Bits = CLng(0)) Or (Channels = CLng(0)) Then Exit Sub
    lngSkip = CLng(m_bytSampleSkip)
    If lngSkip < CLng(1) Then lngSkip = CLng(1)
    lngNumSamples = Size \ (Bits \ CLng(8)) \ Channels \ (lngSkip + CLng(1))
    
    If Channels > CLng(conMaxChannels) Then
        lngChannels = CLng(conMaxChannels)
    Else
        lngChannels = Channels
    End If
    
    If m_blnMixChannels Then
        lngPChannels = CLng(1)
    Else
        lngPChannels = lngChannels
    End If
    
    If lngNumSamples > (m_lngFFTSize \ CLng(&H2)) Then lngNumSamples = m_lngFFTSize \ CLng(&H2)
    'ReDim m_lngBuffer(lngChannels - CLng(1), lngNumSamples - CLng(1))
    ReDim m_lngBuffer(lngChannels - CLng(1), (m_lngFFTSize * CLng(&H2)) - CLng(1))
    'ReDim m_lngBuffer(conMaxChannels - CLng(1), conMaxVisualSamples - CLng(1))
    ReDim m_udtComplex(((m_lngFFTSize * CLng(&H2)) - CLng(1)))
    dblMultiple = CDbl(1)
    
    Select Case Bits
        Case CLng(8)
            ReDim bytBuf8((Size \ LenB(bytBuf8(0))) - CLng(1))
            CopyMemory bytBuf8(0), ByVal BufferPtr, Size
            
            If m_blnMixChannels Then
                'fFFT.Flush;
                For i = CLng(0) To lngNumSamples - CLng(1)
                    lngTemp = CLng(0)
                    
                    For c = CLng(0) To lngChannels - CLng(1)
                        lngTemp = lngTemp + ((CLng(bytBuf8((i * lngChannels * lngSkip) + c)) - CLng(128)) * CLng(256))
                    Next c
                    
                    m_udtComplex(i).re = CDbl(lngTemp) / CDbl(lngChannels)
                    m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                Next i
                
                For i = CLng(0) To m_lngFFTSize - CLng(1)
                    m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                Next i
                
                If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                
                For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                    m_lngBuffer(0, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                Next i
            Else
                For c = CLng(0) To lngChannels - CLng(1)
                    'fFFT.Flush;
                    
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        m_udtComplex(i).re = ((CDbl(bytBuf8(i * lngChannels * lngSkip)) + c) - CDbl(128)) * CDbl(256)
                        m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                    Next i
                    
                    For i = CLng(0) To m_lngFFTSize - CLng(1)
                        m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                    Next i
                    
                    If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                    Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                    
                    For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                        m_lngBuffer(c, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                    Next i
                Next c
            End If
        Case CLng(16)
            ReDim intBuf16((Size \ LenB(intBuf16(0))) - CLng(1))
            CopyMemory intBuf16(0), ByVal BufferPtr, Size
            
            If m_blnMixChannels Then
                'fFFT.Flush;
                For i = CLng(0) To lngNumSamples - CLng(1)
                    lngTemp = CLng(0)
                    
                    For c = CLng(0) To lngChannels - CLng(1)
                        lngTemp = lngTemp + CLng(intBuf16((i * lngChannels * lngSkip) + c))
                    Next c
                    
                    m_udtComplex(i).re = CDbl(lngTemp) / CDbl(lngChannels)
                    m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                Next i
                
                For i = CLng(0) To m_lngFFTSize - CLng(1)
                    m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                Next i
                
                If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                
                For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                    m_lngBuffer(0, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                Next i
            Else
                For c = CLng(0) To lngChannels - CLng(1)
                    'fFFT.Flush;
                    
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        m_udtComplex(i).re = CDbl(intBuf16(i * lngChannels * lngSkip)) + c
                        m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                        'm_udtComplex(i).re = m_udtComplex(i).re + ((CDbl(2) ^ CDbl(16)) \ CDbl(2))    'added to fix frequency gap
                    Next i
                    
                    For i = CLng(0) To m_lngFFTSize - CLng(1)
                        m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                    Next i
                    
                    If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                    Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                    
                    For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                        m_lngBuffer(c, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                    Next i
                Next c
            End If
        Case CLng(24)
            ReDim udtBuf24((Size \ LenB(udtBuf24(0))) - CLng(1))
            CopyMemory udtBuf24(0), ByVal BufferPtr, Size
            
            If m_blnMixChannels Then
                'fFFT.Flush;
                For i = CLng(0) To lngNumSamples - CLng(1)
                    lngTemp = CLng(0)
                    
                    For c = CLng(0) To lngChannels - CLng(1)
                        lngTemp = lngTemp + (Cvt24BitTo32(udtBuf24((i * lngChannels * lngSkip) + c))) \ CLng(256)
                    Next c
                    
                    m_udtComplex(i).re = CDbl(lngTemp) / CDbl(lngChannels)
                    m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                Next i
                
                For i = CLng(0) To m_lngFFTSize - CLng(1)
                    m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                Next i
                
                If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                
                For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                    m_lngBuffer(0, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                Next i
            Else
                For c = CLng(0) To lngChannels - CLng(1)
                    'fFFT.Flush;
                    
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        m_udtComplex(i).re = CDbl(Cvt24BitTo32(udtBuf24(i * lngChannels * lngSkip)) + c) / CDbl(256)
                        m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                    Next i
                    
                    For i = CLng(0) To m_lngFFTSize - CLng(1)
                        m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                    Next i
                    
                    If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                    Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                    
                    For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                        m_lngBuffer(c, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                    Next i
                Next c
            End If
        Case CLng(32)
            If Float Then
                ReDim sngBuf32((Size \ LenB(sngBuf32(0))) - CLng(1))
                CopyMemory sngBuf32(0), ByVal BufferPtr, Size
                
                If m_blnMixChannels Then
                    'fFFT.Flush;
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        lngTemp = CLng(0)
                        
                        For c = CLng(0) To lngChannels - CLng(1)
                            lngTemp = lngTemp + CLng(Round(CDbl(sngBuf32((i * lngChannels * lngSkip) + CDbl(c))) * CDbl(32767)))
                        Next c
                        
                        m_udtComplex(i).re = CDbl(lngTemp) / CDbl(lngChannels)
                        m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                    Next i
                    
                    For i = CLng(0) To m_lngFFTSize - CLng(1)
                        m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                    Next i
                    
                    If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                    Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                    
                    For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                        m_lngBuffer(0, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                    Next i
                Else
                    For c = CLng(0) To lngChannels - CLng(1)
                        'fFFT.Flush;
                        
                        For i = CLng(0) To lngNumSamples - CLng(1)
                            m_udtComplex(i).re = Round((CDbl(sngBuf32(i * lngChannels * lngSkip)) + CDbl(c)) * CDbl(32768))
                            m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                        Next i
                        
                        For i = CLng(0) To m_lngFFTSize - CLng(1)
                            m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                        Next i
                        
                        If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                        Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                        
                        For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                            m_lngBuffer(c, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                        Next i
                    Next c
                End If
            Else
                ReDim lngBuf32i((Size \ LenB(lngBuf32i(0))) - CLng(1))
                CopyMemory lngBuf32i(0), ByVal BufferPtr, Size
                
                If m_blnMixChannels Then
                    'fFFT.Flush;
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        lngTemp = CLng(0)
                        
                        For c = CLng(0) To lngChannels - CLng(1)
                            lngTemp = lngTemp + (lngBuf32i((i * lngChannels * lngSkip) + c) \ CLng(65536))
                        Next c
                        
                        m_udtComplex(i).re = CDbl(lngTemp) / CDbl(lngChannels)
                        m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                    Next i
                    
                    For i = CLng(0) To m_lngFFTSize - CLng(1)
                        m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                    Next i
                    
                    If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                    Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                    
                    For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                        m_lngBuffer(0, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                    Next i
                Else
                    For c = CLng(0) To lngChannels - CLng(1)
                        'fFFT.Flush;
                        
                        For i = CLng(0) To lngNumSamples - CLng(1)
                            m_udtComplex(i).re = (CDbl(lngBuf32i(i * lngChannels * lngSkip)) + c) / CDbl(65536)
                            m_udtComplex(i).re = (CDbl(2) * m_udtComplex(i).re) - CDbl(32768)       'Fix
                        Next i
                        
                        For i = CLng(0) To m_lngFFTSize - CLng(1)
                            m_udtComplex(i).re = GetWindowingValue(m_udtComplex(i).re, i, m_lngFFTSize, m_enuWindow)
                        Next i
                        
                        If m_blnEnablePreEmphasis Then Call DoPreEmphasis(m_udtComplex(), CDbl(m_bytPreEmphasis) / CDbl(100))
                        Call FFTComplex(lngNumSamples, False, m_udtComplex(), udtComplexReturn())
                        
                        For i = CLng(0) To ((m_lngFFTSize * CLng(&H2)) - CLng(1))
                            m_lngBuffer(c, i) = Round(FFTSum(udtComplexReturn(i).re, udtComplexReturn(i).im))
                        Next i
                    Next c
                End If
            End If
    End Select
    
    Select Case m_lngFFTSize
        Case fts2
            dblMultiple = CDbl(11)
        Case fts4
            dblMultiple = CDbl(10)
        Case fts8
            dblMultiple = CDbl(9)
        Case fts16
            dblMultiple = CDbl(8)
        Case fts32
            dblMultiple = CDbl(7)
        Case fts64
            dblMultiple = CDbl(6)
        Case fts128
            dblMultiple = CDbl(5)
        Case fts256
            dblMultiple = CDbl(4)
        Case fts512
            dblMultiple = CDbl(3.2)
        Case fts1024
            dblMultiple = CDbl(2.4)
        Case fts2048
            dblMultiple = CDbl(1.5)
        Case fts4096
            dblMultiple = CDbl(1.2)
        Case fts8192
            dblMultiple = CDbl(1)
    End Select
    
    lngRange = m_lngMaxY - m_lngMinY
    
    For c = CLng(0) To lngChannels - CLng(1)
        For i = CLng(0) To (m_lngFFTSize * CDbl(&H2)) - CLng(1)
            dblTemp2 = CDbl(m_lngBuffer(c, i)) * dblMultiple - CDbl(50000)
            If dblTemp2 < CDbl(0) Then dblTemp2 = CDbl(0)
            dblTemp2 = dblTemp2 * lngRange / CDbl(700000)
            If m_blnLogarithmic Then dblTemp2 = Sqr(dblTemp2 * CDbl(lngRange))
            m_lngBuffer(c, i) = Round(dblTemp2 + CDbl(m_lngMinY))
        Next i
    Next c
    
    RaiseEvent OnSpectrumData(m_lngBuffer(), m_lngMinY, m_lngMaxY, lngNumSamples, lngPChannels)
End Sub

Public Sub Flush()
    Erase m_lngBuffer
    
    'Dim lngChannel As Long
    'Dim lngSample As Long
    '
    'For lngChannel = CLng(0) To CLng(conMaxChannels) - CLng(1)
    '    For lngSample = CLng(0) To CLng(conMaxVisualSamples) - CLng(1)
    '        m_lngBuffer(lngChannel, lngSample) = CLng(0)
    '    Next lngSample
    'Next lngChannel
    '
    'Call ZeroMemory(m_lngBuffer(0, 0), CLng(conMaxChannels) * CLng(conMaxVisualSamples))
End Sub

Private Function Cvt24BitTo32(Sample As T24BitSample) As Long
    If Sample.a2 <= CLng(127) Then
        Cvt24BitTo32 = CLng(Sample.a0) + (CLng(Sample.a1) * CLng(&H100)) + (CLng(Sample.a2) * CLng(&H10000))
    Else
        Cvt24BitTo32 = CLng(Sample.a0) + (CLng(Sample.a1) * CLng(&H100)) + ((CLng(Sample.a2) - CLng(256)) * CLng(&H10000))
    End If
End Function

Private Function EnsureRange(ByVal bytValue As Byte, ByVal bytMin As Byte, ByVal bytMax As Byte) As Byte
    If bytValue < bytMin Then
        EnsureRange = bytMin
    ElseIf bytValue > bytMax Then
        EnsureRange = bytMax
    Else
        EnsureRange = bytValue
    End If
End Function

Private Function FFTSum(ByVal Real As Double, ByVal Imag As Double) As Double
    FFTSum = Sqr((Real ^ CDbl(2) + Real ^ CDbl(2)))
End Function

Private Function GetWindowingValue(ByVal Value As Double, ByVal Index As Long, ByVal FFTSize As Long, ByVal Window As TWindowMode) As Double
    Dim dblReturn As Double
    
    Select Case Window
        Case wmRectangular
            dblReturn = Value
        Case wmBlackmanHarris
            'Result := Value * (0.35875 - 0.48829 * cos(TWO_PI * (Index + 0.5) / FFTSize) + 0.14128 * cos(TWO_PI * 2 * (Index + 0.5) / FFTSize) - 0.01168 * cos(TWO_PI * 3 * (Index + 0.5) / FFTSize));
            dblReturn = Value * (CDbl(0.35875) - CDbl(0.48829) * Cos(CDbl(conTwoPi) * (CDbl(Index) * CDbl(0.5)) / CDbl(FFTSize)) + CDbl(0.14128) * Cos(CDbl(conTwoPi) * CDbl(2) * (CDbl(Index) + CDbl(0.5)) / CDbl(FFTSize)) - CDbl(0.01168) * Cos(CDbl(conTwoPi) * CDbl(3) * (CDbl(Index) + CDbl(0.5)) / CDbl(FFTSize)))
        Case wmHamming
            'Result := Value * (0.54 - (0.46 * cos(TWO_PI * Index / FFTSize)));
            dblReturn = Value * (CDbl(0.54) - (CDbl(0.46) * Cos(CDbl(conTwoPi) * CDbl(Index) / CDbl(FFTSize))))
        Case wmHanning
            'Result := Value * (0.50 - (0.50 * cos(TWO_PI * Index / FFTSize)));
            dblReturn = Value * (CDbl(0.5) - (CDbl(0.5) * Cos(CDbl(conTwoPi) * CDbl(Index) / CDbl(FFTSize))))
        Case wmBlackman
            'Result := Value * (0.42 - 0.50 * cos(TWO_PI * Index / FFTSize) + 0.08 * cos(FOUR_PI * Index / FFTSize));
            dblReturn = Value * (CDbl(0.42) - CDbl(0.5) * Cos(CDbl(conTwoPi) * CDbl(Index) / CDbl(FFTSize)) + CDbl(0.08) * Cos(CDbl(conFourPi) * CDbl(Index) / CDbl(FFTSize)))
        Case wmGaussian
            'Result := Value * (exp(-5.0 / (sqr(FFTSize)) * (2 * Index - FFTSize) * (2 * Index - FFTSize)));
            dblReturn = Value * (Exp(-CDbl(5) / (Sqr(CDbl(FFTSize))) * (CDbl(2) * CDbl(Index) - CDbl(FFTSize)) * (CDbl(2) * CDbl(Index) - CDbl(FFTSize))))
        Case wmBartlett
            'if Index < (FFTSize div 2) then Result := Value * (2 * Index / (FFTSize - 1))
            '                           else Result := Value * (2 - (2 * Index / (FFTSize - 1)));
            
            If Index < (FFTSize \ CLng(2)) Then
                dblReturn = CDbl(Value) * (CDbl(2) * CDbl(Index) / (CDbl(FFTSize) - CDbl(1)))
            Else
                dblReturn = CDbl(Value) * (CDbl(2) - (CDbl(2) * CDbl(Index) / (CDbl(FFTSize) - CDbl(1))))
            End If
    End Select
    
    GetWindowingValue = dblReturn
End Function
